<?php
/*
* $Id: optional_related_products.php
* $Loc: /admin/
*
* Name: RelatedProducts
* Version: 7.5.7
* Release Date: 2024-10-22
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under the GNU General Public License
*
* Comments: Author: [Rainer Schmied @raiwa]
* Author URI: [www.phoenixcartaddons.com]
* 
* CE Phoenix, E-Commerce made Easy
* https://phoenixcart.org
* 
* Copyright (c) 2021 Phoenix Cart
* 
* 
*/

  require('includes/application_top.php');

  $languages = language::load_all();

  // function get products model
  function get_products_model($product_id) {
    $product_query = $GLOBALS['db']->query(sprintf(<<<'EOSQL'
SELECT products_model
  FROM products
  WHERE products_id = %s
EOSQL
      , (int)$product_id));
    $product = $product_query->fetch_assoc();
    return $product['products_model'] ?? '';
  }

  // function get products name
  function get_products_name($product_id) {
    $product_query = $GLOBALS['db']->query(sprintf(<<<'EOSQL'
SELECT products_name
  FROM products_description
  WHERE products_id = %s
EOSQL
      , (int)$product_id));

    $product = $product_query->fetch_assoc();
    return $product['products_name']?? '';
  }

  $action = $_GET['action'] ?? '';

  $related_page = $_GET['related_page'] ?? null;

  $products_id_view = $_GET['products_id_view'] ?? '';
  $products_id_master  = $_GET['products_id_master'] ??  null;
  $products_id_slave = $_GET['products_id_slave'] ?? null;
  if ($products_id_master) $products_id_view = $products_id_master;

  if ( defined('MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL') && defined('MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME') ) {
    if ( MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True' && MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') {
      $MenuOrderBy = ' ORDER BY pd.products_name, p.products_model';
    } elseif (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') {
      $MenuOrderBy = ' ORDER BY pd.products_name';
    } elseif (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True') {
      $MenuOrderBy = ' ORDER BY p.products_model';
    }
  }

  if (!empty($action)) {
    $page_info = '';
    if (isset($_GET['related_page'])) $page_info = 'related_page=' . $_GET['related_page'] . '&';
    if (!Text::is_empty($page_info)) {
      $page_info = substr($page_info, 0, -1);
    }

    $products_id_master = $_REQUEST['products_id_master'] ?? null;
    $products_id_slave = $_REQUEST['products_id_slave'] ?? null;
    $pop_order_id = $_REQUEST['pop_order_id'] ?? null;
    $pop_id = $_REQUEST['pop_id'] ?? null;

    switch ($action) {
      case 'Insert':
        if ($products_id_master != $products_id_slave) {
          $check = $db->query(sprintf(<<<'EOSQL'
SELECT p.pop_id
  FROM products_related_products p
  WHERE p.pop_products_id_master = %s
    AND p.pop_products_id_slave = %s
EOSQL
          , (int)$products_id_master, (int)$products_id_slave));

          if ( !$check->fetch_assoc() ) {
            $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_related_products
  VALUES ('', '%s', '%s', '%s')
EOSQL
            , (int)$products_id_master, (int)$products_id_slave, (int)$pop_order_id));

          }
        }
        Href::redirect($Admin->link('optional_related_products.php')->retain_query_except(['action']));
        break;

      case 'Reciprocate':
        if ($products_id_master != $products_id_slave) {
          $check = $db->query(sprintf(<<<'EOSQL'
SELECT p.pop_id
  FROM products_related_products p
  WHERE p.pop_products_id_master = %s
    AND p.pop_products_id_slave = %s
EOSQL
          , (int)$products_id_master, (int)$products_id_slave));

          if (!$check->fetch_assoc()) {
            $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_related_products
  VALUES ('', '%s', '%s', '%s')
EOSQL
            , (int)$products_id_master, (int)$products_id_slave, (int)$pop_order_id));

          }
          $check = $db->query(sprintf(<<<'EOSQL'
SELECT p.pop_id
  FROM products_related_products p
  WHERE p.pop_products_id_master = %s
    AND p.pop_products_id_slave = %s
EOSQL
          , $products_id_slave, $products_id_master));


          if (!$check->fetch_assoc()) {
            $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_related_products
  VALUES ('', '%s', '%s', '%s')
EOSQL
          , (int)$products_id_slave, (int)$products_id_master, (int)$pop_order_id));

          }
        }
        Href::redirect($Admin->link('optional_related_products.php')->retain_query_except(['action']));
        break;

      case 'Inherit':
        if ($products_id_master != $products_id_slave) {
          if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_INSERT_AND_INHERIT == 'True') {
            $check = $db->query(sprintf(<<<'EOSQL'
SELECT p.pop_id
  FROM products_related_products p
  WHERE p.pop_products_id_master = %s
    AND p.pop_products_id_slave = %s
EOSQL
            , $products_id_master, $products_id_slave));

            if (!$check->fetch_assoc()) {
              $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_related_products
  VALUES ('', '%s', '%s', '%s')
EOSQL
               , (int)$products_id_master, (int)$products_id_slave, (int)$pop_order_id));

            }
          }
          $products = $db->query(sprintf(<<<'EOSQL'
SELECT p.pop_products_id_slave
  FROM products_related_products p
  WHERE p.pop_products_id_master = %s
  ORDER BY p.pop_id
EOSQL
          , $products_id_slave));

          while ($products_values = $products->fetch_assoc()) {
            $products_id_slave2 = $products_values['pop_products_id_slave'];
            if ($products_id_master != $products_id_slave2) {
              $check = $db->query(sprintf(<<<'EOSQL'
SELECT p.pop_id
  FROM products_related_products p
  WHERE p.pop_products_id_master = %s
    AND p.pop_products_id_slave = %s
EOSQL
              , (int)$products_id_master, (int)$products_id_slave2));

              if ( !$check->fetch_assoc() ) {
                $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_related_products
  VALUES ('', '%s', '%s', '%s')
EOSQL
          , (int)$products_id_master, (int)$products_id_slave2, (int)$pop_order_id));

              }
            }
          }
        }
        Href::redirect($Admin->link('optional_related_products.php')->retain_query_except(['action']));
        break;

      case 'update_product_attribute':
        $db->query(sprintf(<<<'EOSQL'
UPDATE products_related_products
  SET pop_products_id_master = %s, pop_products_id_slave = %s, pop_order_id = %s
  WHERE pop_id = %s
EOSQL
          , (int)$products_id_master, (int)$products_id_slave, (int)$pop_order_id, (int)$pop_id));

        Href::redirect($Admin->link('optional_related_products.php')->retain_query_except(['action'])->set_parameter('products_id_view', $products_id_view));
        break;
      case 'delete_attribute':
        $pop_id = $_GET['pop_id'] ?? null;
        $db->query(sprintf(<<<'EOSQL'
DELETE
  FROM products_related_products
  WHERE pop_id = %s
EOSQL
        , (int)$pop_id));

        Href::redirect($Admin->link('optional_related_products.php')->retain_query_except(['action', 'pop_id']));
        break;
      case 'maintenance':
        $db->query(<<<'EOSQL'
DELETE
  FROM products_related_products
  WHERE pop_products_id_master
    NOT IN(SELECT products_id
           FROM products
           WHERE products_id IS NOT NULL)
    OR pop_products_id_slave
    NOT IN(SELECT products_id
           FROM products
           WHERE products_id IS NOT NULL)
EOSQL
        );

        Href::redirect($Admin->link('optional_related_products.php')->retain_query_except(['action', 'products_id_master', 'products_id_slave', 'pop_order_id']));
        break;
    }
  }

  require('includes/template_top.php');

  if ( defined('MODULE_CONTENT_PI_RELATED_PRODUCTS_STATUS') ) { // check if product info module installed
?>
  <div class="row">
    <div class="col">
      <h1 class="display-4 mb-2"><?php echo HEADING_TITLE_RELATED . ' ' . MODULE_CONTENT_PI_RELATED_PRODUCTS_VERSION_INSTALLED . '</h1><h4><a target="_blank" href="http://www.oscaddons.com/en/commercial-add-ons/related-products-pro-p-43.html">' . TEXT_GET_PRO . '</a></h4>'; ?>
    </div>
    <div class="col text-right align-self-center">
      <?= new Button(TEXT_CONFIGURATION, 'fas fa-cogs', 'btn-light', [], $Admin->link('modules.php')->set_parameter('set', 'content')->set_parameter('module', 'cm_pi_related_products')->set_parameter('action', 'edit')) ?>
    </div>
  </div>
<?php
    $related_what = "p.products_id";
    $related_from =  " FROM products p, products_related_products pa";
    $related_where =  " WHERE pa.pop_products_id_master = p.products_id";
    if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True') {
      $related_what .= ", p.products_model";
    }
    if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') {
      $related_what .= ", pd.products_name";
      $related_from .=  ", products_description pd";
      $related_where .=  " AND p.products_id = pd.products_id";
      $related_where .=  " AND pd.language_id = '" . $languages_id . "'";
    }

    $related_query_raw = "SELECT DISTINCT " . $related_what . $related_from . $related_where . ' ' . $MenuOrderBy;
    $related_query = $db->query($related_query_raw);

    $products_array[] = ['id' => '',
                       'text' => TEXT_SHOW_ALL_PRODUCTS];

    while ( $related_values = $related_query->fetch_assoc() ) {
      $model = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True')? $related_values['products_model'] . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR : '' ;
      $name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True')? $related_values['products_name'] : '' ;
      $products_array[] = ['id' => $related_values['products_id'],
                         'text' => $model . $name ];
    }
?>

    <?= new Form('select_product', $Admin->link('optional_related_products.php'), 'get') ?>
      <div class="form-group row mt-5">
        <label for="productsIdView" class="col-form-label col-sm-3 text-left text-sm-right"><?= TITLE_SELECT_PRODUCT ?></label>
        <div class="col-sm-9">
          <?= $select = new Select('products_id_view', $products_array, ['value' => ($_GET['products_id_view'] ?? ''), 'id' => 'productsIdView', 'class' => 'form-control', 'onchange' => 'this.form.submit();']) ?>
        </div>
      </div>
    </form>
<?php
    if ($action == 'update_attribute') {
      $form_action = 'update_product_attribute';
    } else {
      $form_action = 'add_product_relations';
    }

    if (!isset($related_page)) {
      $related_page = 1;
    }
    $prev_related_page = $related_page - 1;
    $next_related_page = $related_page + 1;
    $form_params = 'action=' . $form_action . '&related_page=' . $related_page;

?>
    <div class="row no-gutters">
      <div class="col-12">
        <?= new Form('relations', $Admin->link('optional_related_products.php'), 'get', ['action' => $form_action, 'related_page' => $related_page]) ?>
          <div class="table-responsive">
            <table class="table table-striped table-hover">
              <thead class="thead-light">
                <tr>
                  <th>
<?php
    $per_page = MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_ROW_LISTS_OPTIONS;

    $related_query_raw = sprintf(<<<'EOSQL'
SELECT pa.*, p.*, pd.products_id
  FROM products_related_products pa
  LEFT JOIN products p
    ON pa.pop_products_id_master = p.products_id
  LEFT JOIN products_description pd
    ON pa.pop_products_id_master = pd.products_id
    AND pd.language_id = %s
EOSQL
          , (int)$_SESSION['languages_id']);

    if ($products_id_view) {
      $related_query_raw .= " WHERE pd.products_id = '" . $products_id_view . "'"; }
      $related_query_raw .= $MenuOrderBy . ", pa.pop_order_id, pa.pop_id";

      $related_values = $db->query($related_query_raw);

      $related_page_start = ($per_page * $related_page) - $per_page;
      $num_rows = mysqli_num_rows($related_values);

      if ($num_rows <= $per_page) {
        $num_pages = 1;
      } else if (($num_rows % $per_page) == 0) {
        $num_pages = ($num_rows / $per_page);
      } else {
        $num_pages = ($num_rows / $per_page) + 1;
      }
      $num_pages = (int) $num_pages;

      $related_query = $db->query($related_query_raw . " LIMIT " . $related_page_start . ", " . $per_page);

      $view_id = '';
      if ($products_id_view) {
        $products_id_view = $products_id_master?$products_id_master:$products_id_view;
        $view_id = '&products_id_view=' . $products_id_view;
      }

      // Previous
      if ($prev_related_page) {
        echo '       <a href="' . $Admin->link('optional_related_products.php')->retain_query_except()->set_parameter('related_page', $prev_related_page . $view_id) . '"> &lt;&lt; </a> | ';
      }

      for ($i = 1; $i <= $num_pages; $i++) {
        if ($i != $related_page) {
          echo '    <a href="' . $Admin->link('optional_related_products.php')->retain_query_except()->set_parameter('related_page', $i . $view_id) . '">' . $i . '</a> | ';
        } else {
          echo '    <span class="text-danger"><b>' . $i . '</b></span> | ';
        }
      }

      // Next
      if ($related_page != $num_pages) {
        echo '      <a href="' . $Admin->link('optional_related_products.php')->retain_query_except()->set_parameter('related_page', $next_related_page . $view_id) . '"> &gt;&gt; </a>';
      }
?>
                  </th>
                </tr>
              </thead>
            </table>
            <table class="table table-striped table-hover">
              <thead class="thead-dark">
                <tr>
                  <th><?= TABLE_HEADING_REL_ID ?></th>
                  <th><?= ((MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True') ? TABLE_HEADING_MODEL . ' ' . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR . ' ' : '') . ((MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') ? TABLE_HEADING_PRODUCT : '') . ' ' . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR . ' ' . TABLE_HEADING_RELATED ?></th>
                  <th><?= ((MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True') ? TABLE_HEADING_MODEL . ' ' . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR . ' ' : '') . ((MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') ? TABLE_HEADING_PRODUCT : '') ?></th>
                  <th class="text-center"><?= TABLE_HEADING_ORDER ?>&nbsp;</th>
                  <th class="text-center"><?= TABLE_HEADING_ACTION ?>&nbsp;</th>
                </tr>
              </thead>
<?php
      $next_id = 1;
      $rows = 0;
      $mId = null;
      $sId = null;
      $mModel = null;
      $sModel = null;
      while ( $relations_values = $related_query->fetch_assoc() ) {

        if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True') {
          $mModel = get_products_model($relations_values['pop_products_id_master']) . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR . ' ';
          $sModel = get_products_model($relations_values['pop_products_id_slave']) . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR . ' ';
        }
        if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') {
          $products_name_master = get_products_name($relations_values['pop_products_id_master']);
          $products_name_slave = get_products_name($relations_values['pop_products_id_slave']);
        }

        $pop_order_id = $relations_values['pop_order_id'];
        $rows++;
?>
              <tbody>
                <tr class="<?= (floor($rows/2) == ($rows/2) ? 'attributes-even' : 'attributes-odd') ?>">
<?php
      if (($action == 'update_attribute') && ($_GET['pop_id'] == $relations_values['pop_id'])) {
?>
                  <td>
                    <?= $relations_values['pop_id'] ?>
                    <?= new Input('pop_id', ['value' => $relations_values['pop_id']], 'hidden') ?>
                  </td>
                  <td>
                    <select name="products_id_master" class="form-control">
<?php
        // edit relation master product menu
        $related_what = "p.products_id";
        $related_from =  " FROM products p";
        $related_where =  " WHERE p.products_id > '0'";
        if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True') {
          $related_what .= ", p.products_model";
        }
        if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') {
          $related_what .= ", pd.products_name";
          $related_from .=  ", products_description pd";
          $related_where .=  " AND p.products_id = pd.products_id";
          $related_where .=  " AND pd.language_id = '" . $_SESSION['languages_id'] . "'";
        }

        $related_query_raw = "SELECT DISTINCT " . $related_what . $related_from . $related_where . ' ' . $MenuOrderBy;
        $related_query = $db->query($related_query_raw);
        $related_query_slave = $db->query($related_query_raw);

        while( $products_values = $related_query->fetch_assoc() ) {
          $model = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True')? $products_values['products_model'] . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR : '';
          $name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True')? $products_values['products_name'] : '';
          $product_name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_NAME_LENGTH == '0')? $name:substr($name, 0, MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_NAME_LENGTH);
          echo '        <option id="a' . $products_values['products_id'] . '" value="' . $products_values['products_id'] . '"' . (($relations_values['pop_products_id_master'] == $products_values['products_id'])? ' selected' : '') . '>' . $model . $product_name . '</option>';
        }
?>
                    </select>
                  </td>
                  <td>
                    <select name="products_id_slave" class="form-control">
<?php
        // edit relation slave product menu
        while( $products_values = $related_query_slave->fetch_assoc()) {
          $model = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True')?$products_values['products_model'] . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR:'';
          $name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True')?$products_values['products_name']:'';
          $product_name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_NAME_LENGTH == '0')?$name:substr($name, 0, MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_NAME_LENGTH);
          echo '        <option id="b' . $products_values['products_id'] . '" value="' . $products_values['products_id'] . '"' . (($relations_values['pop_products_id_slave'] == $products_values['products_id'])? ' selected' : '') . '>' . $model . $product_name . '</option>';
        }
?>
                    </select>
                  </td>
                  <td class="text-center"><?= new Input('pop_order_id', ['id' => 'pop_order_id', 'value' => $relations_values['pop_order_id'], 'class' => 'w-25 text-center']) ?></td>
                  <td class="text-center"><?= new Input('action', ['value' => 'update_product_attribute'], 'hidden') .  new Button(IMAGE_UPDATE, 'fas fa-sync-alt', 'btn-outline-info btn-sm') . '&nbsp;' . new Button(IMAGE_CANCEL, 'fas fa-times', 'btn-outline-dark btn-sm', [], $Admin->link('optional_related_products.php')->set_parameter('related_page', $related_page)->set_parameter('products_id_view', $products_id_view)) ?></td>
<?php
      } else {
        //  basic browse table list
?>
                  <td><?= $relations_values["pop_id"] ?>&nbsp;</td>
                  <td><?= $mId . $mModel . ((MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_DISPLAY_LENGTH == '0') ? $products_name_master : substr($products_name_master, 0, MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_DISPLAY_LENGTH)) ?></td>
                  <td><?= $sId . $sModel . ((MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_DISPLAY_LENGTH == '0') ? $products_name_slave : substr($products_name_slave, 0, MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_DISPLAY_LENGTH)) ?></td>
                  <td class="text-center"><?= $pop_order_id ?></td>
                  <td class="text-center">
<?php
        echo new Button(IMAGE_EDIT, 'fas fa-pencil-alt', 'btn-outline-info btn-sm', [], $Admin->link('optional_related_products.php')->set_parameter('action', 'update_attribute')->set_parameter('pop_id', $relations_values['pop_id'])->set_parameter('related_page', $related_page)->set_parameter('products_id_view', $products_id_view)) . '&nbsp;';
        if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_CONFIRM_DELETE == 'False') {
          echo new Button(IMAGE_DELETE, 'fas fa-trash', 'btn-outline-danger btn-sm', [], $Admin->link('optional_related_products.php')->set_parameter('action', 'delete_attribute')->set_parameter('pop_id', $relations_values['pop_id'])->set_parameter('related_page', $related_page)->set_parameter('products_id_view', $products_id_view));
        } else {
          echo new Button(IMAGE_DELETE, 'fas fa-trash', 'btn-outline-danger btn-sm', ['onClick' => 'return confirm(\'' .  strip_tags(sprintf(TEXT_CONFIRM_DELETE, str_replace('"', '', $products_name_slave), str_replace('"', '', $products_name_master))) . '\');'], $Admin->link('optional_related_products.php')->set_parameter('action', 'delete_attribute')->set_parameter('pop_id', $relations_values['pop_id'])->set_parameter('related_page', $related_page)->set_parameter('products_id_view', $products_id_view));
        }
?>
                  </td>
<?php
      }
      $max_relations_id_query = $db->query("select max(pop_id) + 1 as next_id from products_related_products");
      $max_relations_id_values = $max_relations_id_query->fetch_assoc();
      $next_id = $max_relations_id_values['next_id'];
?>
                 </tr>
<?php
    }
?>
                <tbody>
              </table>
<?php
    if ($action != 'update_attribute') {
?>
              <table class="table table-striped table-hover">
                <thead class="thead-light">
                  <tr>
                  <th><b><?= TABLE_HEADING_REL_ID ?></b></th>
                  <th><b><?= TEXT_MASTER_PRODUCTS ?></b></th>
                  <th><b><?= TEXT_SLAVE_PRODUCTS ?></b></th>
                  <th><b><?= TABLE_HEADING_ORDER ?></b></th>
                  <th></th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td><?= $next_id ?></td>
                  <td>
                    <select name="products_id_master" class="form-control">
<?php
            $related_what = "p.products_id";
            $related_from =  " FROM products p";
            $related_where =  " WHERE p.products_id > '0'";
            if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True') {
              $related_what .= ", p.products_model";
            }
            if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') {
              $related_what .= ", pd.products_name";
              $related_from .=  ", products_description pd";
              $related_where .=  " AND p.products_id = pd.products_id";
              $related_where .=  " AND pd.language_id = '" . (int)$languages_id . "'";
            }

            $related_query_raw = "SELECT DISTINCT " . $related_what . $related_from . $related_where . ' ' . $MenuOrderBy;
            $related_query = $db->query($related_query_raw);

            $products_id_master = $_GET['products_id_master']?? null;
            if (!$products_id_master) {
              $products_id_master = $products_id_view;
            }

            while ( $products_values = $related_query->fetch_assoc() ) {
              $model = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True')?$products_values['products_model'] . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR:'';
              $name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True')?$products_values['products_name']:'';
              $product_name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_NAME_LENGTH == '0')?$name:substr($name, 0, MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_NAME_LENGTH);
              echo '  <option id="c' . $products_values['products_id'] . '" value="' . $products_values['products_id'] . '"' . (($products_id_master == $products_values['products_id'])? ' selected' : '') . '>' . $model . $product_name . '</option>';
            }
?>
                  </select>
                </td>
                <td>
                  <select name="products_id_slave" class="form-control">
<?php
            $related_what = "p.products_id";
            $related_from =  " FROM products p";
            $related_where =  " WHERE p.products_id > '0'";
            if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True') {
              $related_what .= ", p.products_model";
            }
            if (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True') {
              $related_what .= ", pd.products_name";
              $related_from .=  ", products_description pd";
              $related_where .=  " AND p.products_id = pd.products_id";
              $related_where .=  " AND pd.language_id = '" . $languages_id . "'";
            }

            $related_query_raw = "SELECT DISTINCT " . $related_what . $related_from . $related_where . ' ' . $MenuOrderBy;
            $related_query = $db->query($related_query_raw);

            while ( $products_values = $related_query->fetch_assoc() ) {
              $model = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_MODEL == 'True')?$products_values['products_model'] . MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MODEL_SEPARATOR:'';
              $name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_USE_NAME == 'True')?$products_values['products_name']:'';
              $product_name = (MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_NAME_LENGTH == '0')?$name:substr($name, 0, MODULE_CONTENT_PI_ADMIN_RELATED_PRODUCTS_MAX_NAME_LENGTH);
              echo '<option id="d' . $products_values['products_id'] . '" value="' . $products_values['products_id'] . '"' . (($products_id_slave == $products_values['products_id'])? ' selected' : '') . '>' . $model . $product_name . '</option>';
            }
?>
                  </select>
                </td>
                <td><?= new Input('pop_order_id', ['id' => 'pop_order_id', 'class' => 'form-control w-25 text-center']) ?></td>
                <td></td>
              </tr>
                </tbody>
              </table>
            </div>
            <div class="col-md-12 d-flex justify-content-center">
              <div class="button-group">
                <?= new Button(BUTTON_INSERT, 'fas fa-arrow-right', 'btn-outline-dark', ['name'  => 'action', 'value' => 'Insert']) ?>
                <?= new Button(BUTTON_RECIPROCATE, 'fas fa-arrows-alt-h', 'btn-outline-dark', ['name'  => 'action', 'value' => 'Reciprocate']) ?>
                <?= new Button(BUTTON_INHERIT, 'fas fa-arrow-down', 'btn-outline-dark', ['name'  => 'action', 'value' => 'Inherit']) ?>
              </div>
            </div>
            <hr>
            <div class="alert alert-warning text-center" role="alert">
              <?= '<p class="my-2">' . TITLE_MAINTENANCE . '<br><small>' , TEXT_MAINTENANCE . '</small> ' . new Button(BUTTON_MAINTENANCE, 'fas fa-trash', 'btn-sm btn-outline-danger', ['name'  => 'action', 'value' => 'maintenance']) . '</p>' ?>
            </div>
            <?= new Input('products_id_view', ['value' => $products_id_view], 'hidden') ?>
          </form>
<?php
    }
?>
      </div>
    </div>
<?php
} else { //product info module not installed
?>
    <div class="col">
      <h1 class="display-4 mb-2"><?= HEADING_TITLE_RELATED . ' ' . '</h1><h4><a target="_blank" href="http://www.oscaddons.com/en/commercial-add-ons/related-products-pro-p-43.html">' . TEXT_GET_PRO . '</a></h4>' ?>
    </div>
    <div class="alert alert-warning text-center" role="alert">
      <h4><?= TEXT_MODULE_INSTALL ?></h4>
      <?= new Button(TEXT_INSTALL, 'fas fa-cogs', 'btn-info btn-lg btn-block', [], $Admin->link('modules.php')->set_parameter('set', 'content')->set_parameter('list', 'new')->set_parameter('module', 'cm_pi_related_products')) ?>
<?php
}

  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>